aboutsummaryrefslogtreecommitdiffstats
path: root/git-sh-setup.sh
diff options
context:
space:
mode:
authorFredrik Kuivinen <freku045@student.liu.se>2005-12-11 10:55:49 +0100
committerJunio C Hamano <junkio@cox.net>2005-12-14 02:53:43 -0800
commitd025524d9d85b057c3caae68a8398eaf7ba3be1a (patch)
tree862f4530063e150444ab61b4a9e293f5fef0e903 /git-sh-setup.sh
parent01f49e3453d9960fec62d93bc3a66784f1be4c26 (diff)
downloadgit-d025524d9d85b057c3caae68a8398eaf7ba3be1a.tar.gz
Usage message clean-up, take #2
There were some problems with the usage message clean-up patch series. I hadn't realised that subdirectory aware scripts can't source git-sh-setup. I propose that we change this and let the scripts which are subdirectory aware set a variable, SUBDIRECTORY_OK, before they source git-sh-setup. The scripts will also set USAGE and possibly LONG_USAGE before they source git-sh-setup. If LONG_USAGE isn't set it defaults to USAGE. If we go this way it's easy to catch --help in git-sh-setup, print the (long) usage message to stdout and exit cleanly. git-sh-setup can define a 'usage' shell function which can be called by the scripts to print the short usage string to stderr and exit non-cleanly. It will also be easy to change $0 to basename $0 or something else, if would like to do that sometime in the future. What follows is a patch to convert a couple of the commands to this style. If it's ok with everyone to do it this way I will convert the rest of the scripts too. [jc: thrown in to proposed updates queue for comments.] Signed-off-by: Junio C Hamano <junkio@cox.net>
Diffstat (limited to 'git-sh-setup.sh')
-rwxr-xr-xgit-sh-setup.sh34
1 files changed, 29 insertions, 5 deletions
diff --git a/git-sh-setup.sh b/git-sh-setup.sh
index b4f10224ba..1e638e493d 100755
--- a/git-sh-setup.sh
+++ b/git-sh-setup.sh
@@ -11,13 +11,37 @@
# exporting it.
unset CDPATH
-: ${GIT_DIR=.git}
-: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
-
die() {
echo >&2 "$@"
exit 1
}
-# Make sure we are in a valid repository of a vintage we understand.
-GIT_DIR="$GIT_DIR" git-var GIT_AUTHOR_IDENT >/dev/null || exit
+usage() {
+ die "Usage: $0 $USAGE"
+}
+
+if [ -z "$LONG_USAGE" ]
+then
+ LONG_USAGE="Usage: $0 $USAGE"
+else
+ LONG_USAGE="Usage: $0 $USAGE
+
+$LONG_USAGE"
+fi
+
+case "$1" in
+ --h|--he|--hel|--help)
+ echo "$LONG_USAGE"
+ exit
+esac
+
+if [ -z "$SUBDIRECTORY_OK" ]
+then
+ : ${GIT_DIR=.git}
+ : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
+
+ # Make sure we are in a valid repository of a vintage we understand.
+ GIT_DIR="$GIT_DIR" git-var GIT_AUTHOR_IDENT >/dev/null || exit
+else
+ GIT_DIR=$(git-rev-parse --git-dir) || exit
+fi